library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity fifo_gen is
  port (
    p_clk    : in std_logic;
    p_resetn : in std_logic;
    p_w      : out std_logic;
    p_wok    : in  std_logic;
    p_data   : out std_logic_vector(7 downto 0));
end fifo_gen;

architecture rtl of fifo_gen is
  
  signal reg_next : std_logic_vector(7 downto 0) := X"00";
  signal reg      : std_logic_vector(7 downto 0) := X"00";
  
begin  -- rtl

  -- purpose: update register
  -- type   : combinational
  -- inputs : p_clk
  -- outputs: reg
  foo: process (p_clk)
  begin  -- process foo
    if rising_edge(p_clk) then
      if p_resetn = '0' then
        reg <= X"00";
      elsif p_wok = '1' then
        reg <= reg_next;
      end if;
    end if;
  end process;

  p_data <= reg;
  p_w <= '1';
  reg_next <= reg + 1;
  
end rtl;
